import java.io.*;
import java.util.Vector;
import java.lang.Object;

public class BPlusTree implements Serializable{

    Node _root;
    String _type;

    public BPlusTree(String type) {
        _root = null;
        _type = type;

    } 


    public  void BKLoad(Vector newData) { 
if (newData == null) 
System.out.println("Null Vector");
        BTBulkLoad load = new BTBulkLoad(newData);
        _root = load.buildTree();
        if (_root == null)
                System.out.println(" root = null");
        else {
              System.out.println("arity of root = "+_root._arity);
            for (int i = 0; i < _root._arity;i++)
                System.out.print("key : " + _root._keys[i]+ "child "+_root._children[i]);
            System.out.println("");
        }
    }

    

    

    
/*
    public BTree(String key, Object value) {
        _root = new Node(key,value);
        LeafNode leaf = new LeafNode(key,value);
      
    }

    public static void main(String[] args) {
        BPlusTree tree = new BPlusTree();

        Vector treeV = new Vector();
        for (int i = 0; i < 9; i++) 
            treeV.addElement(new Integer(i));

        tree.insert("hello", treeV);
    }

*/
        
    public void insert(String key, Object values) {
          
           NodeEntry newNode = _root.insert(key, values);
           if (newNode != null) {
              Node newRoot = new Node();
              newRoot._children[0] = _root;
              newRoot._children[1] = newNode._child;
              newRoot._keys[0] = newNode._key;
              _root = newRoot;
              _root._arity = 1; 

           }
              
    }

/*
    public void insert(String key, Object value) {

        Vector valueVec = search(key);

        if (valueVec == null) {
            valueVec = new Vector();
            valueVec.addElement(value);
            LeafNode leaf = findLeaf(key);
            addKey(key,leaf);
        }
        else
            valueVec.addElement(value);
    }

    public Vector search(String key) {
        
        Node currNode = _root;
    }

*/

    public Vector lookup(String key) {
        
        return ((Vector) _root.lookup(key));
    }

    public void insert(String key, Vector fileNoS) {

        _root.insert(key, fileNoS);
    }
    
    public Leaf getLeafHead() {
        Object child = _root._children[0];
        while (child instanceof Node)
              child = ((Node)child)._children[0];
        return ((Leaf) child);
    } 

    public void leafRemove(Vector delV) {
    
        Leaf currLeaf = getLeafHead(); 
        while (currLeaf != null) {
              currLeaf.leafRemove(delV);
              currLeaf = currLeaf._next;
        }
    }

    public void keyedLeafRemove(String[] delKeys, Vector[] delVals) {
        Leaf currLeaf = getLeafHead();
        while (currLeaf != null) {
              int res = currLeaf.keyedLeafRemove(delKeys, delVals);
              
              if (res >0)
                  currLeaf = currLeaf._next;
              else
                 return;
        }
    }

    public void leafPrint() {
  System.out.println(" in Leaf Pring"); 
        Leaf currLeaf = getLeafHead(); 
 if (currLeaf == null)
System.out.println(" curr Leaf is null");
        while (currLeaf != null) {
            int leafSize = currLeaf._arity;
System.out.println("arity = " + leafSize);
            for (int i = 0; i < leafSize; i++) {
                System.out.print(" key : " +currLeaf._keys[i]);
                int listSize = currLeaf._values[i].size();
                System.out.print(" values : ");
                for (int j = 0; j <listSize;j++)  {
                    System.out.print((currLeaf._values[i]).elementAt(j));
                }
                System.out.println("");
            }
            currLeaf = currLeaf._next;
        }
    }
    
}
          
            
            
            
