/* This file will execute the Unix command after the arguments has been
 * converted into real file name with absolute path for Unix command.
 */

import java.util.*;
import java.io.*;

public class Command implements Runnable {

    // the command to be executed
    private Vector command;

    private Runtime r;
    private Process p;

    /* constructor */
    public Command(Vector vec) {
	command = vec;
    }

    public void run() {

	// the length of the command
	int len = command.size();
	
	String argv[] = new String[len];
	for (int i=0; i<len; i++) 
	    argv[i] = (String)command.elementAt(i);

	// execute the command
	r = Runtime.getRuntime();
	try {
	    p = r.exec(argv);
	}
	catch (IOException e) { 
	    System.out.println("ERROR: " + e.toString());
	    System.exit(0);
	}

	//Input stdin = new Input(this.p);
	//Thread s = new Thread(stdin);

	Output stdout = new Output(this.p);
        Thread t = new Thread(stdout);

	Error stderr = new Error(this.p);
	Thread r = new Thread(stderr);

	//if (argv[0].equals("vi"))
	//  s.start();
	t.start();
	r.start();

	try {
	    //  if (argv[0].equals("vi"))
	    //s.join();
	    t.join();
	    r.join();
	}
	catch (InterruptedException e) {
	    System.out.println("ERROR: " + e.toString());
	    System.exit(0);
	}
    }
} // command class

