import java.io.*;
import java.util.*;

public class Modify{
    public static void main(String[] args){
	
	//get 3 vectors of deleted files, modified files and created files
	ModifiedFiles mf = new ModifiedFiles("/afs/cs.wisc.edu/u/q/i/qing/private/cs367/p2grade");
	mf.modifyFileV();

	System.out.println("***** deletedFiles *****");
	for (int i = 0; i< ourDB.deletedFiles.size(); i++){
	    ModFileEntry entry = (ModFileEntry)(ourDB.deletedFiles.get(i));
	    System.out.println(entry.fileNumber + ") "+ entry.path);
	}

	System.out.println("***** modifiedFiles *****");
	for (int i = 0; i< ourDB.modifiedFiles.size(); i++){
	    ModFileEntry entry = (ModFileEntry)(ourDB.modifiedFiles.get(i));
	    System.out.println(entry.fileNumber + ") "+ entry.path);
	}

	System.out.println("***** createdFiles *****");
	for (int i = 0; i< ourDB.createdFiles.size(); i++){
	    ModFileEntry entry = (ModFileEntry)(ourDB.createdFiles.get(i));
	    System.out.println(entry.fileNumber + ") "+ entry.path);
	}
 
	//delete all the related data of deletedFiles and ModifiedFiles
	//in tree leafs
	if(ourDB.deletedFiles.size()!=0){
	    ourDB.bptreeText.leafRemove(ourDB.deletedFiles);
	    for(int i = 0; i<6; i++)
		ourDB.bptreeMeta[i].leafRemove(ourDB.deletedFiles);
	}
	if(ourDB.modifiedFiles.size()!=0){
	    ourDB.bptreeText.leafRemove(ourDB.modifiedFiles);
	    for(int i = 0; i<6; i++)
		ourDB.bptreeMeta[i].leafRemove(ourDB.modifiedFiles);
	}
	ourDB.bptreeText.leafPrint();
	ourDB.bptreeMeta[4].leafPrint();

	//Retrieve information again
	WordExtractor we = new WordExtractor();
	we.modifyFileWord();

	MetaData md = new MetaData();
	md.modifyFileMeta();
	/*
	MailTrans mt = new MailTrans();
	JavaTrans jt = new JavaTrans();
	CTrans ct = new CTrans();

	for (int i=0; i<ourDB.modifiedFiles.size(); i++){
	    ModFileEntry entry = (ModFileEntry)(ourDB.modifiedFiles.get(i));
	    int fileNum = entry.fileNumber;
	    String type = ((FileInfoEntry)(ourDB.fileInfoV.get(fileNum))).fileType;
	    String path = entry.path;
	    if(type.equals("mail")){
		mt.getData(path);
	    }
	    else if(type.equals("java")){
		jt.getData(path);
	    }
	    else if(type.equals("c")){
		ct.getData(path);
	    }
	    else
		continue;
	}

	for (int i=0; i<ourDB.createdFiles.size(); i++){
	    ModFileEntry entry = (ModFileEntry)(ourDB.createdFiles.get(i));
	    int fileNum = entry.fileNumber;
	    String type = ((FileInfoEntry)(ourDB.fileInfoV.get(fileNum))).fileType;
	    String path = entry.path;
	    if(type.equals("mail")){
		mt.getData(path);
	    }
	    else if(type.equals("java")){
		jt.getData(path);
	    }
	    else if(type.equals("c")){
		ct.getData(path);
	    }
	    else
		continue;
	}
	*/
    }
}


