import java.io.*;

class Output implements Runnable{
    private Process proc;
    public Output(Process p){
	proc = p;
    }//constructor
    public void run(){
	String c;
	BufferedReader in = new BufferedReader(new InputStreamReader(proc.getInputStream()));
	BufferedWriter out = new BufferedWriter(new OutputStreamWriter(System.out));
	try{
	    while((c = in.readLine()) != null){
		//out.write(c,0,c.length());
		//out.flush();
		System.out.println(c);
	    }
	    System.out.flush();
	}catch(IOException exception){
	    System.out.println("Input problem. Terminating.");
	    System.exit(1);
	}
    }//method run
}


