#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>//for open()
#include <sys/mman.h>//for mmap()
#include <unistd.h> //for close()
#include <stdio.h>
#include "ModifiedFiles.h"
#include <jni.h>
#include <iostream.h>

JNIEXPORT jlongArray JNICALL Java_ModifiedFiles_getModTime
    (JNIEnv *env, jobject jobj, jstring name) {
    jlong j1[1];
    jlongArray jl;
    jboolean iscopy;
    struct stat finfo;
    const char *mfile = env->GetStringUTFChars(name, &iscopy);
    int fd = open(mfile, O_RDONLY);
    if (fd == -1) {
	printf("Could not open %s\n", mfile);
    }
    stat(mfile, &finfo);
    jl = env->NewLongArray(6);
    j1[0] = (long)finfo.st_mtime;//The time of last data modification
    //printf("The last modification time is: %d\n", j1[0]);
    env -> SetLongArrayRegion(jl, 0, 1, j1);
    close(fd);
    env->ReleaseStringUTFChars(name, mfile);
    return (jl);

}
