/* After query parsing process read in a simple query, it will store 
 * all the information of this simple query into an object of this
 * class.
 */
import java.io.*;

public class SimpleQueryEntry {

    /* the field can be "field", "type", "owner", "modTime", "text"
     * "size". */
    public String field; // which field the user is querying on

    public String value; // the desired value of the field

    // constructor
    public SimpleQueryEntry(String f, String v) {

	field = f;
	value = v;
    }

    public void print() {

	System.out.println("field: " + field + "   value: " + value);
    }
}
