import java.io.*;
import java.util.*;

public class TestBuild implements Serializable{
    public static void main(String[] args){
	
	//Vector fileInfo = new Vector();
	//Vector oldFiles = new Vector();
	//BPlusTree btree = new BPlusTree("TEXT");

	try{
	    FileInputStream fis = new FileInputStream("writetemp");
	    ObjectInputStream in = new ObjectInputStream(fis);
	    ourDB.fileInfoV = (Vector)(in.readObject());
	    in.close();
	}catch(Exception e){
	    System.out.println(e);
	}
	
	System.out.println("\n***** FileInfoV *****");
	for (int i = 0; i < ourDB.fileInfoV.size(); i++){
	    FileInfoEntry entry = (FileInfoEntry)(ourDB.fileInfoV.get(i));
	    System.out.println(i +") "+entry.filePathName);
	    System.out.println(entry.fileType);
	}

	try{
	    FileInputStream fis = new FileInputStream("oldFiles");
	    ObjectInputStream in = new ObjectInputStream(fis);
	    ourDB.oldFiles = (Vector)(in.readObject());
	    in.close();
	}catch(Exception e){
	    System.out.println(e);
	}

	System.out.println("\n***** oldFiles *****");
	for (int i = 0; i < ourDB.oldFiles.size(); i++){
	    MidModEntry entry = (MidModEntry)(ourDB.oldFiles.get(i));
	    System.out.println(entry.fileNumber +") "+entry.path);
	    System.out.println(entry.modTime + " " + entry.mark);
	}
	/*
	ConvertTime ct = new ConvertTime();
	long[] time;
	time = ct.parseDate("3/6/2000 20:32:00");//LinkedList.java
	System.out.println("LinkedList.java is last modified at "+time[0]);
	*/

	try{
	    FileInputStream fis = new FileInputStream("TEXT_INDEX");
	    ObjectInputStream in = new ObjectInputStream(fis);
	    ourDB.bptreeText = (BPlusTree)(in.readObject());
	    in.close();
	}catch(Exception e){
	    System.out.println(e);
	}
	System.out.println("\n***** TEXT_INDEX *****");
	ourDB.bptreeText.leafPrint();
	
	try{
	    FileInputStream fis = new FileInputStream("META_OWNER_INDEX");
	    ObjectInputStream in = new ObjectInputStream(fis);
	    ourDB.bptreeMeta[0] = (BPlusTree)(in.readObject());
	    in.close();
	}catch(Exception e){
	    System.out.println(e);
	}
	System.out.println("\n***** META_OWNER_INDEX *****");
	ourDB.bptreeMeta[0].leafPrint();

	try{
	    FileInputStream fis = new FileInputStream("META_GROUP_INDEX");
	    ObjectInputStream in = new ObjectInputStream(fis);
	    ourDB.bptreeMeta[1] = (BPlusTree)(in.readObject());
	    in.close();
	}catch(Exception e){
	    System.out.println(e);
	}
	System.out.println("\n***** META_GROUP_INDEX *****");
	ourDB.bptreeMeta[1].leafPrint();

	try{
	    FileInputStream fis = new FileInputStream("META_SIZE_INDEX");
	    ObjectInputStream in = new ObjectInputStream(fis);
	    ourDB.bptreeMeta[2] = (BPlusTree)(in.readObject());
	    in.close();
	}catch(Exception e){
	    System.out.println(e);
	}
	System.out.println("\n***** META_SIZE_INDEX *****");
	ourDB.bptreeMeta[2].leafPrint();

	try{
	    FileInputStream fis = new FileInputStream("META_ACCESST_INDEX");
	    ObjectInputStream in = new ObjectInputStream(fis);
	    ourDB.bptreeMeta[3] = (BPlusTree)(in.readObject());
	    in.close();
	}catch(Exception e){
	    System.out.println(e);
	}
	System.out.println("\n***** META_ACCESST_INDEX *****");
	ourDB.bptreeMeta[3].leafPrint();

	try{
	    FileInputStream fis = new FileInputStream("META_MODT_INDEX");
	    ObjectInputStream in = new ObjectInputStream(fis);
	    ourDB.bptreeMeta[4] = (BPlusTree)(in.readObject());
	    in.close();
	}catch(Exception e){
	    System.out.println(e);
	}
	System.out.println("\n***** META_MODT_INDEX *****");
	ourDB.bptreeMeta[4].leafPrint();

	try{
	    FileInputStream fis = new FileInputStream("META_CHANGET_INDEX");
	    ObjectInputStream in = new ObjectInputStream(fis);
	    ourDB.bptreeMeta[5] = (BPlusTree)(in.readObject());
	    in.close();
	}catch(Exception e){
	    System.out.println(e);
	}
	System.out.println("\n***** META_CHANGET_INDEX *****");
	ourDB.bptreeMeta[5].leafPrint();
    }

}






